

     #######   #####   ######    #####    #####    #####   ######  ######  #     #
        #     #     #  #     #  #     #  #     #  #     #  #       #       ##   ##
        #           #  #     #        #  #     #  #     #  #       #       # # # #
        #      #####   #     #   #####   #     #  #     #  #####   #####   #  #  #
        #           #  #     #  #        #     #  #     #  #       #       #     #
        #     #     #  #     #  #        #     #  #     #  #       #       #     #
        #      #####   ######   #######   #####    #####   #       ######  #     #



                             Convertor from T3d to OOFEM


                         Copyright: Daniel Rypl 1998 - 2008



                        Czech Technical University in Prague
                Faculty of Civil Engineering, Department of Mechanics
                      Thakurova 7, 166 29 Prague, Czech Republic
                               email: drypl@fsv.cvut.cz

============================================================================================

Execution:
==========

t3d2oofem control_file t3d_output_file oofem_in_file


Control file format:
====================
control lines of oofem input file without mesh
(also the line with numbers of records is without the first two entries 
corresponding to the number of nodes and elements)

e.g.: test.out
      testing example
      linearstatic nsteps 1 
      domain 3d
      outputmanager tstep_all dofman_all element_all
      1 1 4 0 1
      simplecs 1 thick 0.25
      isole 1 d 4850.0 e 210e6 n 0.300000 talpha 1.2e-6
      boundarycondition 1 loadtimefunction 1 prescribedvalue 0.0
      constantsurfaceload 2 loadtimefunction 1 components 3 0.0 0.0 -10.0 loadtype 3 ndofs 3
      nodalload 3 loadtimefunction 1 components 3 -2.5 0.0 0.0
      deadweight 4 loadtimefunction 1 components 3 0.0 0.0 -1.0
      constantfunction 1 f(t) 1.0

node property, element property, element type and boundary load specifications (see below)

e.g.: vertex all except 1 2 3 4 5 6
      curve 1 2
      nodeprop bc 3 1 0 0

      vertex 1 2
      curve 3
      nodeprop 3 1 1 1

      vertex 5 6
      curve 4
      nodeprop load 3

      region all
      elemprop crosssect 1 mat 1 bodyloads 1 4
      tetratype LTrSpace

      surface 2 4
      boundaryload 2

-----------------------------------------------------------------------------------------------

note: empty lines in the specification section are ignored
      lines starting with # (hash) are treated as comments

note: for correct run of t3d2oofem it is necessary to run t3d with 
      -p 8 or -p 512 option

note: application of edge load to 3D elements requires to run t3d
      with -p 512 options, otherwise this load will be ignored

------------------------------------------------------------------------------------------------

model entity specification:
===========================
entity_name {all [except enumeration] | enumeration}

e.g.: vertex all except 1 2
      curve all
      surface 1 2 11 12
      patch 24
      shell 13 14
      region 1

note: includes all elements but only interior nodes of each entity
note: model entity specification is valid for all the subsequent
node property, element property, element type, boundary load or boundary
condition specifications until a new model entity or property specification
is encountered (or until the keyword cancel is encountered)


property specification:
=======================
property {all [except enumeration] | enumeration}

e.g.: property 2

note: model entity specification is valid for all the subsequent
node property, element property, element type, boundary load or boundary
condition specifications until a new model entity or property specification
is encountered (or until the keyword cancel is encountered)


node property specification:
============================
model entity or property specification (see above)
nodeprop oofem_string 

e.g.: nodeprop bc 3 1 1 0 load 3


element property specification:
===============================
model entity or property specification (see above)
elemprop oofem_string

e.g.: elemprop crosssect 1 mat 1 bodyloads 1 4


element type specification:
===========================
model entity specification (see above)
{elemtype | edgetype | triatype | quadtype | tetratype | hexatype} oofem_elem_type

e.g.: tetratype LTrSpace

note: keyword elemtype is depreciated; it is implemented only for
compatibility reasons; use appropriate specific type keyword or
keywords (if more element types are expected to appear in the region)


boundary load specification:
============================
model entity specification (see above)
boundaryload load_number

e.g.: boundaryload 2
or    bload 2


boundary condition specification:
=================================
model entity specification (see above)
boundarycode code_number

e.g.: boundarycode 3
or    bcode 3

------------------------------------------------------------------------------------------------

Important notes:
================

In t3d output file, the mesh entities are classified to the entity of
the lowest dimension. This implies that boundary nodes of a particular
model entity are not classified to that model entity but to other
model entity of possible lowest dimension. For example, boundary nodes
of surface are classified to boundary curves of that surface or
boundary vertices of those curves. Also note that mesh entities are
classified to the top parent physical entity. This implies that if
there is a physical curve c1 fixed to part of another physical curve c2
(not fixed to any physical curve), then the edges on curve c1 (if
subjected to the output) will be classified to c2. As a consequence,
curve c1 will appear as nonexisting and cannot be therefore subjected
to boundary conditions etc. Should you need to apply these boundary
conditions you must enforce curve c1 to appear in t3d output by
changing the model (for example by changing curve c2 to virtual
and fixing to it not only curve c1 but also curve c3 on its remaining
part). 

When handling surfaceload, it is always applied to all elements
incident to particular face. For example, if there are two spatial
regions sharing a common surface subjected to surfaceload, then
surfaceload will be applied to both elements sharing the face on the
common surface. Thus to enforce proper response, the amplitude of the
loading should be scaled appropriately. Since there is generally not
possible that the number of elements on one side of the surface is
different from that on the other side of the surface, the scaling
should be always possible. This behaviour is the consequence of the
current implementation generating the oofem input file on the fly 
without storing any mesh data.

When handling edgeload it is always applied to just a single element
incident to particular edge. For example, if there are two planar
domains sharing a common curve subjected to edgeload, then edgeload
will be always applied to just one of the two elements sharing the
edge on the common curve. This is important when handling the above
described case of curve c1 fixed to part of curve c2, subjected to
edge load. This behaviour is also crucial when handling edge load
subjected to curve bounding 3D elements as there may be several
elements sharing the same edge on that curve.

